Index: squid3/src/ipc.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/ipc.cc,v
retrieving revision 1.8.2.21
retrieving revision 1.8.2.22
diff -u -r1.8.2.21 -r1.8.2.22
--- squid3/src/ipc.cc	14 May 2006 17:11:06 -0000	1.8.2.21
+++ squid3/src/ipc.cc	3 Sep 2006 16:51:26 -0000	1.8.2.22
@@ -34,1400 +34,252 @@
  */
 
 #include "squid.h"
-#include "ipc.h"
 #include "comm.h"
 #include "fde.h"
-#include "SquidTime.h"
-
-#ifdef _SQUID_MSWIN_
-#ifndef _MSWSOCK_
-#include <mswsock.h>
-#endif
-#include <process.h>
-#endif
-
-class FDPair
-{
-
-public:
-    FDPair() : rfd (-1), wfd (-1) {}
-
-    FDPair (int anFD) : rfd (anFD), wfd (anFD) {}
-
-    FDPair (int r, int w) : rfd (r), wfd (w) {}
-
-    void close();
-    int rfd;
-    int wfd;
-};
-
-
-/* XXX: The mechanics could be made into a strategy and this
-   class a parent for classes that need to spawn.
-   For now, a callforward will do. Alternatively we could
-   make this a template class and use a unary functor.
-   */
-
-class Spawn
-{
-
-public:
-    static Spawn *GetSpawn();
-    virtual ~Spawn(){}
-
-    virtual Spawn *clone() const = 0;
-    virtual bool success() const = 0;
-    /* For windows, until the spawn object is kept around */
-    virtual void * getHandle() const = 0;
-    virtual pid_t getPid() const = 0;
-    typedef unsigned int Child (void *);
-    virtual void splitExecution(Child*, void *) = 0;
-    // virtual ... startProcess(prog, args);
-
-protected:
-    Spawn (){}
-
-    Spawn (Spawn const &){}
-
-    Spawn &operator= (Spawn const &);
-
-private:
-};
-
-#ifdef _SQUID_MSWIN_
-
-class WindowsSpawn : public Spawn
-{
-
-public:
-    WindowsSpawn();
-    virtual Spawn *clone() const;
-    virtual bool success() const;
-    /* For windows, until the spawn object is kept around */
-    virtual void * getHandle() const;
-    virtual pid_t getPid() const;
-    virtual void splitExecution(Child*, void *);
-    ~WindowsSpawn();
-
-protected:
-    WindowsSpawn (WindowsSpawn const &);
-    WindowsSpawn &operator= (WindowsSpawn const &);
-
-private:
-    static unsigned int __stdcall ThreadReflector (void *);
-    Child* newThread;
-    void *data;
-    pid_t pid;
-    int error;
-    unsigned int childRV;
-    unsigned threadID;
-    void * threadHandle;
-};
-
-#else
-
-class UnixSpawn : public Spawn
-{
-
-public:
-    UnixSpawn();
-    virtual Spawn *clone() const;
-    virtual bool success() const;
-    /* For windows, until the spawn object is kept around */
-    virtual void * getHandle() const;
-    virtual pid_t getPid() const;
-    virtual void splitExecution(Child*, void *);
-
-protected:
-    UnixSpawn (UnixSpawn const &);
-    UnixSpawn &operator= (UnixSpawn const &);
-
-private:
-    void child();
-    Child* newThread;
-    void *data;
-    pid_t pid;
-};
-
-#endif
-
-Spawn *
-Spawn::GetSpawn()
-{
-#ifdef _SQUID_MSWIN_
-    return new WindowsSpawn;
-#else
-
-    return new UnixSpawn;
-#endif
-}
-
-class IPC
-{
-
-public:
-    static IPC *Create(int type, const char *prog, const char *const args[], const char *name);
-    static unsigned int ForkChild(void *);
-    IPCResult result() const { return rv;}
-
-    virtual ~IPC()
-    {
-        safe_free (name_);
-        delete mySpawn;
-    }
-
-    virtual IPC *clone() const = 0;
-
-    /* FIXME: move below again */
-
-    FDPair childFD;
-
-    virtual struct sockaddr_in & PS ();
-    Spawn *mySpawn;
-    const char *prog;
-    char * const *args;
-    virtual void childFDConnect();
-    virtual bool childFDConnected() const;
-    virtual int childWrite(char const *, size_t) = 0;
-    void doExec();
-
-protected:
-    IPC (char const *aName);
-    IPC(IPC const &);
-
-    /* not implemented, but the synthetic operator won't do */
-    IPC &operator= (IPC const &);
-
-    void result (IPCResult const& newRV)
-    {
-        rv = newRV;
-    }
-
-    char const *name() const {return name_;}
-
-    virtual void markFailed();
-    virtual void cleanUp();
-    virtual bool openedInitialFDs() const;
-
-    virtual struct sockaddr_in & CS ();
-    //  virtual struct sockaddr_in & PS ();
-    virtual void prepFDsForSpawn();
-    virtual bool preppedFDsForSpawn() const;
-    //  virtual void childFDConnect();
-    //  virtual bool childFDConnected() const;
-    int prfd;
-    int pwfd;
-    static IPC *Factory(int type, char const *name);
-
-private:
-    IPC (IPCResult aResult):rv(aResult){}
-
-    void closeAllFD();
-    IPCResult rv;
-    char const *name_;
-};
-
-#ifndef _SQUID_MSWIN_
-#if ! (HAVE_POLL && defined(_SQUID_OSF_))
-
-class IPCFIFO : public IPC
-{
-
-public:
-    virtual IPC *clone() const;
-    virtual int childWrite(char const *, size_t);
-
-private:
-    friend IPC *IPC::Factory(int, char const *);
-    IPCFIFO (char const *aName);
-};
-
-IPCFIFO::IPCFIFO (char const *aName) : IPC(aName)
-{
-    int p2c[2];
-    int c2p[2];
-
-    if (pipe(p2c) < 0) {
-        debug(50, 0) ("ipcCreate: pipe: %s\n", xstrerror());
-        return;
-    }
-
-    if (pipe(c2p) < 0) {
-        debug(50, 0) ("ipcCreate: pipe: %s\n", xstrerror());
-        return;
-    }
-
-    childFD = FDPair (c2p[0], p2c[1]);
-    fdc_open(prfd = p2c[0], FD_PIPE, "IPC FIFO Parent Read");
-    fdc_open(childFD.wfd, FD_PIPE, "IPC FIFO Child Write");
-    fdc_open(childFD.rfd, FD_PIPE, "IPC FIFO Child Read");
-    fdc_open(pwfd = c2p[1], FD_PIPE, "IPC FIFO Parent Write");
-}
-
-IPC *
-IPCFIFO::clone() const
-{
-    IPCFIFO *rv = new IPCFIFO (*this);
-    return rv;
-}
-
-int
-IPCFIFO::childWrite(char const *buf , size_t len)
-{
-    int result = write(childFD.wfd, buf, len);
-
-    if (result < 0)
-        debug(50, 0) ("write FD %d: %s\n", childFD.wfd, xstrerror());
-
-    return result;
-}
-
-#endif
-#endif
-
-class IPCSocket : public IPC
-{
-
-public:
-    virtual IPC *clone() const = 0;
-
-protected:
-    IPCSocket (char const *aName, int socktype, int proto);
-    IPCSocket (IPCSocket const &);
-    /* not implemented */
-    IPCSocket &operator=(IPCSocket const &);
-
-    virtual struct sockaddr_in & CS ();
-
-    virtual struct sockaddr_in & PS ();
-    virtual void prepFDsForSpawn();
-    virtual bool preppedFDsForSpawn() const;
-    bool fdDetailsRetrieved;
-
-private:
-    int openASocket(int socktype, int proto, int flags) const;
-
-    struct sockaddr_in CS_;
-
-    struct sockaddr_in PS_;
-};
-
-IPCSocket::IPCSocket (char const *aName, int socktype, int proto) : IPC (aName),
-        fdDetailsRetrieved (false)
-{
-#ifdef _SQUID_MSWIN_ /* Windows IPC needs Overlapped sockets */
-    int opt = 0;
-    int optlen = sizeof(opt);
-
-    if (WIN32_OS_version !=_WIN_OS_WINNT) {
-        getsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *) &opt, &optlen);
-        opt = opt & ~(SO_SYNCHRONOUS_NONALERT | SO_SYNCHRONOUS_ALERT);
-        setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *) &opt, sizeof(opt));
-    }
-
-#endif
-
-    childFD = FDPair (openASocket (socktype, proto, COMM_NOCLOEXEC));
-
-    prfd = pwfd = openASocket (socktype, proto, 0); /* blocking */
-
-#ifdef _SQUID_MSWIN_ /* Restore sockets to synchronous mode*/
-
-    if (WIN32_OS_version !=_WIN_OS_WINNT) {
-        getsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *) &opt, &optlen);
-        opt = opt | SO_SYNCHRONOUS_NONALERT;
-        setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *) &opt, optlen);
-    }
-
-#endif
-
-}
-
-IPCSocket::IPCSocket (IPCSocket const &old) : IPC(old), fdDetailsRetrieved (old.fdDetailsRetrieved),
-        CS_(old.CS_), PS_(old.PS_)
-{}
-
-struct sockaddr_in &
-            IPCSocket::CS()
-{
-    return CS_;
-}
-
-struct sockaddr_in &
-            IPCSocket::PS()
-{
-    return PS_;
-}
-
-void
-IPCSocket::prepFDsForSpawn()
-{
-    socklen_t len = sizeof(PS_);
-    memset(&PS_, '\0', len);
-
-    if (getsockname(pwfd, (struct sockaddr *) &PS_, &len) < 0) {
-        debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
-        return;
-    }
-
-    debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
-                  pwfd, inet_ntoa(PS_.sin_addr), ntohs(PS_.sin_port));
-    len = sizeof(CS_);
-    memset(&CS_, '\0', len);
-
-    if (getsockname(childFD.rfd, (struct sockaddr *) &CS_, &len) < 0) {
-        debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
-        return;
-    }
-
-    debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
-                  childFD.rfd, inet_ntoa(CS_.sin_addr), ntohs(CS_.sin_port));
-
-    fdDetailsRetrieved = true;
-}
-
-bool
-IPCSocket::preppedFDsForSpawn() const
-{
-    return fdDetailsRetrieved;
-}
-
-int
-IPCSocket::openASocket(int socktype, int proto, int flags) const
-{
-    return comm_open(socktype,
-                     proto,	/* protocol */
-                     local_addr,
-                     0,		/* port */
-                     flags,	/* blocking */
-                     name());
-}
-
-class IPCTCP : public IPCSocket
-{
-
-public:
-    virtual void prepFDsForSpawn();
-    virtual bool preppedFDsForSpawn() const;
-    virtual IPC *clone() const;
-    virtual int childWrite(char const *, size_t);
-
-protected:
-    virtual void childFDConnect();
-    virtual bool childFDConnected() const;
-
-private:
-    friend IPC *IPC::Factory(int, char const *);
-    IPCTCP (char const *aName);
-    bool childConnected;
-};
-
-IPCTCP::IPCTCP (char const *aName) :
-        IPCSocket(aName, SOCK_STREAM, IPPROTO_TCP) , childConnected(false)
-{}
-
-void
-IPCTCP::prepFDsForSpawn()
-{
-    IPCSocket::prepFDsForSpawn();
-
-    if (!IPCSocket::preppedFDsForSpawn())
-        return;
-
-    if (listen(childFD.rfd, 1) < 0) {
-        debug(50, 1) ("ipcCreate: listen FD %d: %s\n", childFD.rfd, xstrerror());
-        /* Naughty abstraction break ! */
-        fdDetailsRetrieved = false;
-        return;
-    }
-
-    debug(54, 3) ("ipcCreate: FD %d listening...\n", childFD.rfd);
-}
-
-bool
-IPCTCP::preppedFDsForSpawn() const
-{
-    /* TODO: heal the abstraction - call this if our flag is ok, otherwise
-     * return false. (See preFDsForSpawn)
-     */
-    return IPCSocket::preppedFDsForSpawn();
-}
-
-IPC *
-IPCTCP::clone() const
-{
-    IPCTCP *rv = new IPCTCP (*this);
-    return rv;
-}
-
-void
-IPCTCP::childFDConnect()
-{
-    debug(54, 3) ("ipcCreate: calling accept on FD %d\n", childFD.rfd);
-    int tempFD;
-
-    if ((tempFD = accept(childFD.rfd, NULL, NULL)) < 0) {
-        debug(50, 0) ("ipcCreate: FD %d accept: %s\n", childFD.rfd, xstrerror());
-        return;
-    }
-
-    debug(54, 3) ("ipcCreate: CHILD accepted new FD %d\n", tempFD);
-
-    comm_close(childFD.rfd);
-#ifdef _SQUID_MSWIN_
-
-    char buf1[8192];
-    snprintf(buf1, 8191, "%s CHILD socket", prog);
-    fdc_open(tempFD, FD_SOCKET, buf1);
-    fd_table[tempFD].flags.ipc = 1;
-#endif
-
-    childFD = FDPair (tempFD);
-
-    childConnected = true;
-}
-
-bool
-IPCTCP::childFDConnected() const
-{
-    return childConnected;
-}
-
-int
-IPCTCP::childWrite(char const *buf , size_t len)
-{
-#ifndef _SQUID_MSWIN_
-    int result = write(childFD.wfd, buf, len);
-
-    if (result < 0)
-        debug(50, 0) ("write FD %d: %s\n", childFD.wfd, xstrerror());
-
-#else
-
-    int result = send (childFD.wfd, (const void *) buf, len, 0);
-
-    if (result < 0)
-        debug(50, 0) ("send FD %d: %s\n", childFD.wfd, xstrerror());
-
-#endif
-
-    return result;
-}
-
-
-class IPCUDP : public IPCSocket
-{
-
-public:
-    virtual IPC *clone() const;
-    virtual int childWrite(char const *, size_t);
-
-protected:
-    virtual void childFDConnect();
-    virtual bool childFDConnected() const;
-
-private:
-    friend IPC *IPC::Factory(int, char const *);
-    IPCUDP (char const *aName);
-    bool childConnected;
-};
-
-IPCUDP::IPCUDP (char const *aName) :
-        IPCSocket(aName, SOCK_DGRAM, IPPROTO_UDP), childConnected (false)
-{}
-
-IPC *
-IPCUDP::clone() const
-{
-    IPCUDP *rv = new IPCUDP (*this);
-    return rv;
-}
-
-void
-IPCUDP::childFDConnect()
-{
-    if (comm_connect_addr(childFD.rfd, &PS()) == COMM_ERROR)
-        return;
-
-    childConnected = true;
-}
-
-bool
-IPCUDP::childFDConnected() const
-{
-    return childConnected;
-}
-
-int
-IPCUDP::childWrite(char const *buf , size_t len)
-{
-    int result = comm_udp_send(childFD.wfd, buf, len, 0);
-
-    if (result < 0)
-        debug(50, 0) ("sendto FD %d: %s\n", childFD.wfd, xstrerror());
-
-    return result;
-}
-
-#if HAVE_SOCKETPAIR && defined(AF_UNIX)
-#ifndef _SQUID_MSWIN_
-
-class IPCUNIXStream : public IPC
-{
-
-public:
-    virtual IPC *clone() const;
-    virtual int childWrite(char const *, size_t);
-
-private:
-    friend IPC *IPC::Factory(int, char const *);
-    IPCUNIXStream (char const *aName);
-};
-
-IPCUNIXStream::IPCUNIXStream (char const *aName) : IPC(aName)
-{
-    int fds[2];
-    int buflen = 32768;
-
-    if (socketpair(AF_UNIX, SOCK_STREAM, 0, fds) < 0) {
-        debug(50, 0) ("ipcCreate: socketpair: %s\n", xstrerror());
-        return;
-    }
-
-    setsockopt(fds[0], SOL_SOCKET, SO_SNDBUF, (void *) &buflen, sizeof(buflen));
-    setsockopt(fds[0], SOL_SOCKET, SO_RCVBUF, (void *) &buflen, sizeof(buflen));
-    setsockopt(fds[1], SOL_SOCKET, SO_SNDBUF, (void *) &buflen, sizeof(buflen));
-    setsockopt(fds[1], SOL_SOCKET, SO_RCVBUF, (void *) &buflen, sizeof(buflen));
-    childFD = FDPair (fds[1]);
-    fdc_open(prfd = pwfd = fds[0], FD_PIPE, "IPC UNIX STREAM Parent");
-    fdc_open(childFD.rfd, FD_PIPE, "IPC UNIX STREAM Child");
-}
-
-IPC *
-IPCUNIXStream::clone() const
-{
-    IPCUNIXStream *rv = new IPCUNIXStream (*this);
-    return rv;
-}
-
-int
-IPCUNIXStream::childWrite(char const *buf , size_t len)
-{
-    int result = write(childFD.wfd, buf, len);
-
-    if (result < 0)
-        debug(50, 0) ("write FD %d: %s\n", childFD.wfd, xstrerror());
-
-    return result;
-}
-
-class IPCUNIXDGram : public IPC
-{
-
-public:
-    virtual IPC *clone() const;
-    virtual int childWrite(char const *, size_t);
-
-private:
-    friend IPC *IPC::Factory(int, char const *);
-    IPCUNIXDGram (char const *aName);
-};
-
-IPCUNIXDGram::IPCUNIXDGram (char const *aName) : IPC(aName)
-{
-    int fds[2];
-
-    if (socketpair(AF_UNIX, SOCK_DGRAM, 0, fds) < 0) {
-        debug(50, 0) ("ipcCreate: socketpair: %s\n", xstrerror());
-        return;
-    }
-
-    childFD = FDPair (fds[1]);
-    fdc_open(prfd = pwfd = fds[0], FD_PIPE, "IPC UNIX DGRAM Parent");
-    fdc_open(childFD.rfd, FD_PIPE, "IPC UNIX DGRAM Child");
-}
-
-IPC *
-IPCUNIXDGram::clone() const
-{
-    IPCUNIXDGram *rv = new IPCUNIXDGram (*this);
-    return rv;
-}
-
-int
-IPCUNIXDGram::childWrite(char const *buf , size_t len)
-{
-    int result = comm_udp_send(childFD.wfd, buf, len, 0);
-
-    if (result < 0)
-        debug(50, 0) ("sendto FD %d: %s\n", childFD.wfd, xstrerror());
-
-    return result;
-}
-
-#endif
-#endif
-
-IPC *
-IPC::Factory (int type, char const *name)
-{
-    if (type == IPC_TCP_SOCKET)
-        return new IPCTCP (name);
-
-#ifndef _SQUID_MSWIN_
-#if !(USE_POLL && defined(_SQUID_OSF_))
-
-    if (type == IPC_FIFO)
-        return new IPCFIFO (name);
-
-#endif
-#endif
-
-    if (type == IPC_UDP_SOCKET)
-        return new IPCUDP (name);
-
-#if HAVE_SOCKETPAIR && defined(AF_UNIX)
-#ifndef _SQUID_MSWIN_
-
-    if (type == IPC_UNIX_STREAM)
-        return new IPCUNIXStream (name);
-
-    if (type == IPC_UNIX_DGRAM)
-        return new IPCUNIXDGram (name);
-
-#endif
-#endif
-
-    fatal ("Unexpected IPC type : check your source\n");
-
-    return NULL;
-}
-
-void
-IPC::markFailed()
-{
-    result(IPCResult(false));
-}
-
-struct sockaddr_in &
-            IPC::CS ()
-{
-    fatal("attempt to get Client Socket for non socket IPC class\n");
-
-    struct sockaddr_in *f = new struct sockaddr_in;
-    return *f;
-}
-
-struct sockaddr_in &
-            IPC::PS ()
-{
-    fatal("attempt to get Parent Socket for non socket IPC class\n");
-
-    struct sockaddr_in *f = new struct sockaddr_in;
-    return *f;
-}
-
-void
-IPC::prepFDsForSpawn()
-{}
-
-bool
-IPC::preppedFDsForSpawn() const
-{
-    return true;
-}
-
-void
-IPC::childFDConnect()
-{}
-
-bool
-IPC::childFDConnected() const
-{
-    return true;
-}
-
-class IPCInstance
-{
-
-public:
-    static char const *ShutdownMessage;
-
-    IPCInstance(int aType, pid_t aPid, char const *program, int fromChildFD, int toParentFD) : type (aType),
-            pid(aPid), prog (xstrdup(program)), prfd (fromChildFD),
-    send_fd (toParentFD){}
-
-    virtual ~IPCInstance()
-    {
-        safe_free(prog);
-    }
-
-    virtual void childToParentLoop();
-
-protected:
-    /* Not implemented */
-    IPCInstance(IPCInstance const &);
-    IPCInstance &operator= (IPCInstance const &);
-
-private:
-    /* what sort of IPC we are */
-    int const type;
-    /* if this is really IPC to another process, the process id. */
-    pid_t pid;
-    /* What program it is */
-    char *prog;
-    /* the parent uses this to read from the child */
-    int const prfd;
-    int const send_fd;
-};
-
-char const *IPCInstance::ShutdownMessage = "$shutdown\n";
-
-#ifdef _SQUID_MSWIN_
-
-struct ipc_params
-{
-    static unsigned int ThreadReflector (void *); // ipc_params *
-    ipc_params (int aType) : type(aType), prfd_ipc (-1), pwfd_ipc(-1), crfd_ipc(-1), cwfd_ipc(-1),
-            hProcess(NULL), thread(NULL), pid (-1), niceprog(NULL)
-#if HAVE_PUTENV
-            , env_str(NULL)
-#endif
-    {
-        p2c[0]=-1;
-        p2c[1]=-1;
-        c2p[0]=-1;
-        c2p[1]=-1;
-    }
-    ~ipc_params()
-    {
-        delete myIPC;
-    }
-
-    int const type;
-    const char *prog;
-    char **args;
-    IPC *myIPC;
-
-private:
-    unsigned int threadLoop();
-    void freeResources();
-    void normalExit();
-    void parentToChildLoop();
-    int p2c[2];
-    int c2p[2];
-    int prfd_ipc, pwfd_ipc, crfd_ipc, cwfd_ipc;
-    HANDLE hProcess;
-    HANDLE thread;
-    pid_t pid;
-    char *niceprog;
-    char buf1[8192];
-#if HAVE_PUTENV
-
-    char *env_str;
-#endif
-};
-
-struct thread_params
-{
-    int type;
-    int rfd;
-    int send_fd;
-    const char *prog;
-    pid_t pid;
-};
-
-static unsigned int __stdcall ipc_thread_2(void *); // thread_params *
-
-static const char *ok_string = "OK\n";
-static const char *err_string = "ERR\n";
-static const char *shutdown_string = "$shutdown\n";
-#endif
 
 static const char *hello_string = "hi there\n";
 #define HELLO_BUF_SZ 32
-static char hello_buf[HELLO_BUF_SZ];
-
-void
-FDPair::close()
-{
-    if (rfd >= 0)
-        comm_close(rfd);
-
-    if (rfd != wfd &&
-            wfd >= 0)
-        comm_close (wfd);
-
-    rfd = wfd = -1;
-}
-
-#ifdef _SQUID_MSWIN_
-static void
-ipcCloseAllFD(int prfd, int pwfd)
-{
-    FDPair (prfd, pwfd).close();
-}
-
-#endif
-
-static void
-PutEnvironment()
-{
-#if HAVE_PUTENV
-    char *env_str;
-    int tmp_s;
-    env_str = (char *)xcalloc((tmp_s = strlen(Config.debugOptions) + 32), 1);
-    snprintf(env_str, tmp_s, "SQUID_DEBUG=%s", Config.debugOptions);
-    putenv(env_str);
-#endif
-}
-
-void
-IPC::closeAllFD()
-{
-    FDPair (prfd, pwfd).close();
-    childFD.close();
-}
-
-void
-IPC::cleanUp()
-{
-    delete mySpawn;
-    mySpawn = NULL;
-    closeAllFD();
-}
-
-void
-reserveFD0Thru2(int crfd)
-{
-    /*
-     * This double-dup stuff avoids problems when one of 
-     *  crfd, cwfd, or debug_log are in the range 0-2.
-     */
-    int openrv;
-
-    do {
-        /* First make sure 0-2 is occupied by something. Gets cleaned up later */
-        openrv = dup(crfd);
-        assert(openrv > -1);
-    } while (openrv < 3 && openrv > -1);
-
-    close(openrv);
-}
-
-void
-IPC::doExec()
-{
-#ifndef _SQUID_MSWIN_
-    int t1, t2, t3;
-    reserveFD0Thru2(childFD.rfd);
-    t1 = dup(childFD.rfd);
-    t2 = dup(childFD.wfd);
-    t3 = dup(fileno(debug_log));
-    assert(t1 > 2 && t2 > 2 && t3 > 2);
-    close(childFD.rfd);
-    close(childFD.wfd);
-    close(fileno(debug_log));
-    dup2(t1, 0);
-    dup2(t2, 1);
-    dup2(t3, 2);
-    close(t1);
-    close(t2);
-    close(t3);
-    /* Make sure all other filedescriptors are closed */
-
-    for (int loopIndex = 3; loopIndex < SQUID_MAXFD; ++loopIndex)
-        close(loopIndex);
-
-    if (opt_no_daemon) {
-        squid_signal(SIGINT, SIG_IGN, SA_RESETHAND);
-        squid_signal(SIGHUP, SIG_IGN, SA_RESETHAND);
-    }
-
-    execvp(prog, (char *const *) args);
-
-    debug_log = fdopen(2, "a+");
-
-    debug(50, 0) ("ipcCreate: %s: %s\n", prog, xstrerror());
-
-    _exit(1);
-
-#else
-    /* NT code goes here eventually */
-#endif
-}
-
-IPCResult
-ipcCreate(int type, const char *prog, const char *const args[], const char *name)
-{
-    IPC *newIPC = IPC::Create(type, prog, args, name);
-    IPCResult result = newIPC->result();
-    delete newIPC;
-    return result;
-}
-
-IPC::IPC(char const *aName): mySpawn(NULL), prfd(-1), pwfd(-1)
-        , rv(false) , name_ (xstrdup(aName))
-{}
-
-/* yes. we have *real* remote ownership issues with prog and args */
-IPC::IPC (IPC const &old):childFD(old.childFD), mySpawn(old.mySpawn->clone()),
-        prog (old.prog), args (old.args),
-        prfd(old.prfd), pwfd (old.pwfd)
-        , rv(old.rv), name_ (xstrdup(old.name_))
-{}
-
-bool
-IPC::openedInitialFDs() const
-{
-    if (childFD.rfd < 0) {
-        debug(54, 0) ("ipcCreate: Failed to create child FD.\n");
-        return false;
-    }
-
-    if (pwfd < 0) {
-        debug(54, 0) ("ipcCreate: Failed to create server FD.\n");
-        return false;
-    }
-
-    return true;
-}
-
-#ifdef _SQUID_MSWIN_
-static int
-ipcSend(int cwfd, const char *buf, int len)
-{
-    int result = send(cwfd, (const void *) buf, len, 0);
-
-    if (result < 0) {
-        debug(50, 0) ("sendto FD %d: %s\n", cwfd, xstrerror());
-        debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
-    }
-
-    return result;
-}
-
-struct SpawnResult
-{
-    SpawnResult() : hProcess (NULL), pid (-1), error (0){}
-
-    HANDLE hProcess;
-    pid_t pid;
-    int error;
-};
-
-static
-SpawnResult
-ipc_spawn(const char *prog, char **args)
-{
-    char buf1[8192];
-    STARTUPINFO si;
-    PROCESS_INFORMATION pi;
-
-    memset(&si, 0, sizeof(STARTUPINFO));
-    si.cb = sizeof(STARTUPINFO);
-    si.hStdInput = (HANDLE) _get_osfhandle(0);
-    si.hStdOutput = (HANDLE) _get_osfhandle(1);
-    si.hStdError = (HANDLE) _get_osfhandle(2);
-    si.dwFlags = STARTF_USESTDHANDLES;
-
-    /* Make sure all other valid handles are not inerithable */
-
-    for (int x = 3; x < SQUID_MAXFD; x++) {
-        fde *F = &fd_table[x];
-
-        if (F->win32.handle == 0)
-            continue;
-
-        SetHandleInformation((HANDLE) F->win32.handle, HANDLE_FLAG_INHERIT, 0);
-    }
-
-    *buf1 = '\0';
-    strcpy(buf1 + 4096, prog);
-    char *str = strtok(buf1 + 4096, w_space);
-
-    do {
-        strcat(buf1, str);
-        strcat(buf1, " ");
-    } while ((str = strtok(NULL, w_space)));
-
-    int loopIndex = 1;
-
-    while (args[loopIndex]) {
-        strcat(buf1, args[loopIndex++]);
-        strcat(buf1, " ");
-    }
-
-    SpawnResult result;
-
-    if (CreateProcess(buf1 + 4096, buf1, NULL, NULL, TRUE, CREATE_NO_WINDOW,
-                      NULL, NULL, &si, &pi)) {
-        result.pid = pi.dwProcessId;
-        result.hProcess = pi.hProcess;
-    } else {
-        WIN32_maperror(GetLastError());
-        result.error = errno;
-    }
-
-    return result;
-}
-
-unsigned int
-ipc_params::ThreadReflector(void *voidParam)
-{
-
-    struct ipc_params *params = static_cast<struct ipc_params *>(voidParam);
-    unsigned int result = params->threadLoop();
-    delete params;
-    return result;
-}
-
-#endif
-
-#ifdef _SQUID_MSWIN_
-
-WindowsSpawn::WindowsSpawn(): newThread (NULL), data(NULL),
-        pid(-1), error (0), childRV (0), threadID (0), threadHandle(NULL)
-{}
-
-WindowsSpawn::WindowsSpawn(WindowsSpawn const &old) : Spawn (old), newThread (old.newThread),
-        data (old.data), pid (old.pid), error (old.error), childRV (old.childRV), threadID (old.threadID)
-{
-    if (old.threadHandle)
-        DuplicateHandle (GetCurrentProcess(), old.threadHandle,GetCurrentProcess(), &threadHandle, 0,FALSE,DUPLICATE_SAME_ACCESS);
-}
-
-WindowsSpawn::~WindowsSpawn()
-{
-    if (threadHandle != NULL)
-        CloseHandle(threadHandle);
-
-    threadHandle = NULL;
-}
-
-unsigned int __stdcall
-WindowsSpawn::ThreadReflector (void *me_)
-{
-    WindowsSpawn *me = static_cast<WindowsSpawn*>(me_);
-    assert (me->newThread != NULL);
-    me->childRV = me->newThread (me->data);
-    return me->childRV;
-}
-
-Spawn *
-WindowsSpawn::clone() const
-{
-    WindowsSpawn *result = new WindowsSpawn (*this);
-    return result;
-}
-
-bool
-WindowsSpawn::success() const
-{
-    return threadID != 0;
-}
-
-void *
-WindowsSpawn::getHandle() const
-{
-    return threadHandle;
-}
-
-pid_t
-WindowsSpawn::getPid() const
-{
-    assert (0);
-    return pid;
-}
+static char hello_buf[HELLO_BUF_SZ];
 
-void
-WindowsSpawn::splitExecution(Spawn::Child *_newThread, void *_data)
+static int
+ipcCloseAllFD(int prfd, int pwfd, int crfd, int cwfd)
 {
-    newThread = _newThread;
-    data = _data;
-    HANDLE beginRv =
-        (HANDLE) _beginthreadex(NULL, 0, ThreadReflector, this, 0, &threadID);
-
-    if (!beginRv) {
-        debug(50, 1) ("ipcCreate: _beginthreadex: %s\n", xstrerror());
-    } else {
-        assert (threadID != 0);
-        /* undocumented! */
-        threadHandle =  beginRv;
-        debug(50, 1) ("WindowsSpawn::splitExecution: Handle: 0x%x, ThreadID: %d\n", (unsigned) threadHandle,threadID);
-    }
-}
+    if (prfd >= 0)
+        comm_close(prfd);
 
-#else
-UnixSpawn::UnixSpawn() :newThread (NULL), data(NULL),
-        pid(-1)
-{}
+    if (prfd != pwfd)
+        if (pwfd >= 0)
+            comm_close(pwfd);
 
-UnixSpawn::UnixSpawn(UnixSpawn const &old)
-{}
+    if (crfd >= 0)
+        comm_close(crfd);
 
-Spawn *
-UnixSpawn::clone() const
-{
-    UnixSpawn *result = new UnixSpawn (*this);
-    return result;
-}
+    if (crfd != cwfd)
+        if (cwfd >= 0)
+            comm_close(cwfd);
 
-bool
-UnixSpawn::success() const
-{
-    return pid > -1;
+    return -1;
 }
 
-void *
-UnixSpawn::getHandle() const
+static void
+PutEnvironment()
 {
-    assert (0);
-    return NULL;
+#if HAVE_PUTENV
+    char *env_str;
+    int tmp_s;
+    env_str = (char *)xcalloc((tmp_s = strlen(Config.debugOptions) + 32), 1);
+    snprintf(env_str, tmp_s, "SQUID_DEBUG=%s", Config.debugOptions);
+    putenv(env_str);
+#endif
 }
 
-pid_t
-UnixSpawn::getPid() const
+int
+ipcCreate(int type, const char *prog, const char *const args[], const char *name, int *rfd, int *wfd)
 {
-    return pid;
-}
+    pid_t pid;
 
-void
-UnixSpawn::splitExecution(Spawn::Child *_newThread, void *_data)
-{
-    newThread = _newThread;
-    data = _data;
+    struct sockaddr_in ChS;
 
-    if ((pid = fork()) < 0) {
-        debug(50, 1) ("ipcCreate: fork: %s\n", xstrerror());
-    } else if (pid > 0) {
-        /* parent */
-        return;
-    } else {
-        /* Still checked outside here */
-        child();
-    }
-}
+    struct sockaddr_in PaS;
+    int crfd = -1;
+    int prfd = -1;
+    int cwfd = -1;
+    int pwfd = -1;
+    int fd;
+    int t1, t2, t3;
+    socklen_t len;
+    int x;
 
-void
-UnixSpawn::child()
-{
-    /*exit(*/newThread(data)/*)*/;
-}
+#if USE_POLL && defined(_SQUID_OSF_)
 
+    assert(type != IPC_FIFO);
 #endif
 
-unsigned int
-IPC::ForkChild(void *data)
-{
-    IPC *result = static_cast<IPC*>(data);
-    assert (result);
-#ifndef _SQUID_MSWIN_
-    /* child */
-    no_suid();			/* give up extra priviliges */
-    /* close shared socket with parent */
-    comm_close(result->prfd);
-
-    if (result->pwfd != result->prfd)
-        close(result->pwfd);
+    if (rfd)
+        *rfd = -1;
 
-    result->pwfd = result->prfd = -1;
-
-#else
-#endif
-
-    /* Until we are entire in this routine */
-    return 0;
-}
+    if (wfd)
+        *wfd = -1;
+
+    if (type == IPC_TCP_SOCKET) {
+        crfd = cwfd = comm_open(SOCK_STREAM,
+                                0,
+                                local_addr,
+                                0,
+                                COMM_NOCLOEXEC,
+                                name);
+        prfd = pwfd = comm_open(SOCK_STREAM,
+                                0,			/* protocol */
+                                local_addr,
+                                0,			/* port */
+                                0,			/* blocking */
+                                name);
+    } else if (type == IPC_UDP_SOCKET) {
+        crfd = cwfd = comm_open(SOCK_DGRAM,
+                                0,
+                                local_addr,
+                                0,
+                                COMM_NOCLOEXEC,
+                                name);
+        prfd = pwfd = comm_open(SOCK_DGRAM,
+                                0,
+                                local_addr,
+                                0,
+                                0,
+                                name);
+    } else if (type == IPC_FIFO) {
+        int p2c[2];
+        int c2p[2];
+
+        if (pipe(p2c) < 0) {
+            debug(50, 0) ("ipcCreate: pipe: %s\n", xstrerror());
+            return -1;
+        }
+
+        if (pipe(c2p) < 0) {
+            debug(50, 0) ("ipcCreate: pipe: %s\n", xstrerror());
+            return -1;
+        }
+
+        fdc_open(prfd = p2c[0], FD_PIPE, "IPC FIFO Parent Read");
+        fdc_open(cwfd = p2c[1], FD_PIPE, "IPC FIFO Child Write");
+        fdc_open(crfd = c2p[0], FD_PIPE, "IPC FIFO Child Read");
+        fdc_open(pwfd = c2p[1], FD_PIPE, "IPC FIFO Parent Write");
+#if HAVE_SOCKETPAIR && defined(AF_UNIX)
 
-IPC *
-IPC::Create (int type, const char *prog, const char *const args[], const char *name)
-{
-    IPC *result = NULL;
-    /* get our candidate object */
-    assert (result = Factory (type, name));
-#ifndef _SQUID_MSWIN_
+    } else if (type == IPC_UNIX_STREAM) {
+        int fds[2];
+        int buflen = 32768;
+
+        if (socketpair(AF_UNIX, SOCK_STREAM, 0, fds) < 0) {
+            debug(50, 0) ("ipcCreate: socketpair: %s\n", xstrerror());
+            return -1;
+        }
+
+        setsockopt(fds[0], SOL_SOCKET, SO_SNDBUF, (void *) &buflen, sizeof(buflen));
+        setsockopt(fds[0], SOL_SOCKET, SO_RCVBUF, (void *) &buflen, sizeof(buflen));
+        setsockopt(fds[1], SOL_SOCKET, SO_SNDBUF, (void *) &buflen, sizeof(buflen));
+        setsockopt(fds[1], SOL_SOCKET, SO_RCVBUF, (void *) &buflen, sizeof(buflen));
+        fdc_open(prfd = pwfd = fds[0], FD_PIPE, "IPC UNIX STREAM Parent");
+        fdc_open(crfd = cwfd = fds[1], FD_PIPE, "IPC UNIX STREAM Parent");
+    } else if (type == IPC_UNIX_DGRAM) {
+        int fds[2];
+
+        if (socketpair(AF_UNIX, SOCK_DGRAM, 0, fds) < 0) {
+            debug(50, 0) ("ipcCreate: socketpair: %s\n", xstrerror());
+            return -1;
+        }
 
-    int tempFD;
+        fdc_open(prfd = pwfd = fds[0], FD_PIPE, "IPC UNIX DGRAM Parent");
+        fdc_open(crfd = cwfd = fds[1], FD_PIPE, "IPC UNIX DGRAM Parent");
 #endif
 
-    int x;
-
-    debug(54, 3) ("ipcCreate: prfd FD %d\n", result->prfd);
-    debug(54, 3) ("ipcCreate: pwfd FD %d\n", result->pwfd);
-    debug(54, 3) ("ipcCreate: crfd FD %d\n", result->childFD.rfd);
-    debug(54, 3) ("ipcCreate: cwfd FD %d\n", result->childFD.wfd);
-
-    if (!result->openedInitialFDs()) {
-        result->cleanUp();
-        return result;
+    } else {
+        assert(IPC_NONE);
     }
 
-    result->prepFDsForSpawn();
+    debug(54, 3) ("ipcCreate: prfd FD %d\n", prfd);
+    debug(54, 3) ("ipcCreate: pwfd FD %d\n", pwfd);
+    debug(54, 3) ("ipcCreate: crfd FD %d\n", crfd);
+    debug(54, 3) ("ipcCreate: cwfd FD %d\n", cwfd);
 
-    if (!result->preppedFDsForSpawn()) {
-        result->cleanUp();
-        return result;
+    if (crfd < 0) {
+        debug(54, 0) ("ipcCreate: Failed to create child FD.\n");
+        return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
     }
 
-    /* flush or else we get dup data if unbuffered_logs is set */
-    logsFlush();
-
-    result->mySpawn = Spawn::GetSpawn();
-
-    result->prog = prog;
-
-    result->args = const_cast<char* const*>(args);
-
-#ifdef _SQUID_MSWIN_
+    if (pwfd < 0) {
+        debug(54, 0) ("ipcCreate: Failed to create server FD.\n");
+        return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
+    }
 
-    ipc_params *params = new ipc_params (type);
+    if (type == IPC_TCP_SOCKET || type == IPC_UDP_SOCKET) {
+        len = sizeof(PaS);
+        memset(&PaS, '\0', len);
 
-    /* Note to self: we must always clone result, even if
-       we eliminate the ipc_params class, because using a single instance
-       might overlap on variable usage. Until the code is fully 
-       reorganised, cloning is safer.
-       Later on we might want to make threadsafe IPC classes ..
-       */
-    params->myIPC = result->clone();
+        if (getsockname(pwfd, (struct sockaddr *) &PaS, &len) < 0) {
+            debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
+        }
 
-    params->prog = prog;
+        debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
+                      pwfd, inet_ntoa(PaS.sin_addr), ntohs(PaS.sin_port));
+        len = sizeof(ChS);
+        memset(&ChS, '\0', len);
 
-    params->args = (char **) args;
+        if (getsockname(crfd, (struct sockaddr *) &ChS, &len) < 0) {
+            debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
+        }
 
-    result->mySpawn->splitExecution ((Spawn::Child *)ipc_params::ThreadReflector, params);
+        debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
+                      crfd, inet_ntoa(ChS.sin_addr), ntohs(ChS.sin_port));
+    }
 
-#else
+    if (type == IPC_TCP_SOCKET) {
+        if (listen(crfd, 1) < 0) {
+            debug(50, 1) ("ipcCreate: listen FD %d: %s\n", crfd, xstrerror());
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
+        }
 
-    result->mySpawn->splitExecution (ForkChild, result);
+        debug(54, 3) ("ipcCreate: FD %d listening...\n", crfd);
+    }
 
-#endif
+    /* flush or else we get dup data if unbuffered_logs is set */
+    logsFlush();
 
-    if (!result->mySpawn->success()) {
-        result->cleanUp();
-        return result;
+    if ((pid = fork()) < 0) {
+        debug(50, 1) ("ipcCreate: fork: %s\n", xstrerror());
+        return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
     }
 
-#ifndef _SQUID_MSWIN_
-    if (result->mySpawn->getPid() > 0) {		/* parent */
+    if (pid > 0) {		/* parent */
         /* close shared socket with child */
-        result->childFD.close();
+        comm_close(crfd);
 
-        if (type == IPC_TCP_SOCKET || type == IPC_UDP_SOCKET) {
-#else
-    {
-        {
-#endif
+        if (cwfd != crfd)
+            comm_close(cwfd);
+
+        cwfd = crfd = -1;
 
-            if (comm_connect_addr(result->pwfd, &result->CS()) == COMM_ERROR)
-            {
-                result->cleanUp();
-                return result;
-            }
+        if (type == IPC_TCP_SOCKET || type == IPC_UDP_SOCKET) {
+            if (comm_connect_addr(pwfd, &ChS) == COMM_ERROR)
+                return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
         }
-        memset(hello_buf, '\0', HELLO_BUF_SZ);
-#ifdef _SQUID_MSWIN_
 
-        x = recv(result->prfd, (void *) hello_buf, HELLO_BUF_SZ - 1, 0);
-#else
+        memset(hello_buf, '\0', HELLO_BUF_SZ);
 
         if (type == IPC_UDP_SOCKET)
-            x = comm_udp_recv(result->prfd, hello_buf, HELLO_BUF_SZ - 1, 0);
+            x = comm_udp_recv(prfd, hello_buf, HELLO_BUF_SZ - 1, 0);
         else
-            x = read(result->prfd, hello_buf, HELLO_BUF_SZ - 1);
-
-#endif
+            x = read(prfd, hello_buf, HELLO_BUF_SZ - 1);
 
-        if (x < 0)
-        {
+        if (x < 0) {
             debug(50, 0) ("ipcCreate: PARENT: hello read test failed\n");
             debug(50, 0) ("--> read: %s\n", xstrerror());
-            result->cleanUp();
-            return result;
-        } else if (strcmp(hello_buf, hello_string))
-        {
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
+        } else if (strcmp(hello_buf, hello_string)) {
             debug(54, 0) ("ipcCreate: PARENT: hello read test failed\n");
             debug(54, 0) ("--> read returned %d\n", x);
             debug(54, 0) ("--> got '%s'\n", rfc1738_escape(hello_buf));
-            result->cleanUp();
-            return result;
-        }
-
-#ifdef _SQUID_MSWIN_
-        x = send(result->pwfd, (const void *) ok_string, strlen(ok_string), 0);
-
-        if (x < 0)
-        {
-            debug(50, 0) ("ipcCreate: PARENT: OK write test failed\n");
-            debug(50, 0) ("--> read: %s\n", xstrerror());
-            result->cleanUp();
-            return result;
-        }
-
-        memset(hello_buf, '\0', HELLO_BUF_SZ);
-        x = recv(result->prfd, (void *) hello_buf, HELLO_BUF_SZ - 1, 0);
-
-        if (x < 0)
-        {
-            debug(50, 0) ("ipcCreate: PARENT: OK read test failed\n");
-            debug(50, 0) ("--> read: %s\n", xstrerror());
-            result->cleanUp();
-            return result;
-        } else if (!strcmp(hello_buf, err_string))
-        {
-            debug(54, 0) ("ipcCreate: PARENT: OK read test failed\n");
-            debug(54, 0) ("--> read returned %d\n", x);
-            debug(54, 0) ("--> got '%s'\n", rfc1738_escape(hello_buf));
-            result->cleanUp();
-            return result;
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
         }
 
-        hello_buf[x] = '\0';
-        pid_t pid = atol(hello_buf);
-        HANDLE HProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, pid);
-
-#endif
-
-        commSetTimeout(result->prfd, -1, NULL, NULL);
-        commSetNonBlocking(result->prfd);
-        commSetNonBlocking(result->pwfd);
-        fd_table[result->prfd].flags.ipc = 1;
-        fd_table[result->pwfd].flags.ipc = 1;
-#ifdef _SQUID_MSWIN_
-
-        fd_table[result->childFD.rfd].flags.ipc = 1;
-        fd_table[result->childFD.wfd].flags.ipc = 1;
-
-        if (Config.sleep_after_fork)
-        {
-            /* XXX emulation of usleep() */
-            DWORD sl;
-            sl = Config.sleep_after_fork / 1000;
-
-            if (sl == 0)
-                sl = 1;
+        commSetTimeout(prfd, -1, NULL, NULL);
+        commSetNonBlocking(prfd);
+        commSetNonBlocking(pwfd);
 
-            Sleep(sl);
-        }
+        if (rfd)
+            *rfd = prfd;
 
-        DWORD ecode = 0;
+        if (wfd)
+            *wfd = pwfd;
 
-        if (GetExitCodeThread(result->mySpawn->getHandle(), &ecode) && ecode == STILL_ACTIVE)
-        {
-            result->result (IPCResult(true, pid, result->prfd, result->pwfd, HProcess));
-            debugs(50, 1, "IPC::Create: Program: " << prog << ", PID: " << ", Handle: 0x" << HProcess);
-
-            return result;
-        } else
-        {
-            result->cleanUp();
-            return result;
-        }
+        fd_table[prfd].flags.ipc = 1;
 
-#else
+        fd_table[pwfd].flags.ipc = 1;
 
-        if (Config.sleep_after_fork)
-        {
+        if (Config.sleep_after_fork) {
             /* XXX emulation of usleep() */
 
             struct timeval sl;
